/*
Copyright 2020 The Jenkins X Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "github.com/jenkins-x/jx-api/v4/pkg/apis/jenkins.io/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakePipelineActivities implements PipelineActivityInterface
type FakePipelineActivities struct {
	Fake *FakeJenkinsV1
	ns   string
}

var pipelineactivitiesResource = v1.SchemeGroupVersion.WithResource("pipelineactivities")

var pipelineactivitiesKind = v1.SchemeGroupVersion.WithKind("PipelineActivity")

// Get takes name of the pipelineActivity, and returns the corresponding pipelineActivity object, and an error if there is any.
func (c *FakePipelineActivities) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.PipelineActivity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(pipelineactivitiesResource, c.ns, name), &v1.PipelineActivity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1.PipelineActivity), err
}

// List takes label and field selectors, and returns the list of PipelineActivities that match those selectors.
func (c *FakePipelineActivities) List(ctx context.Context, opts metav1.ListOptions) (result *v1.PipelineActivityList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(pipelineactivitiesResource, pipelineactivitiesKind, c.ns, opts), &v1.PipelineActivityList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1.PipelineActivityList{ListMeta: obj.(*v1.PipelineActivityList).ListMeta}
	for _, item := range obj.(*v1.PipelineActivityList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested pipelineActivities.
func (c *FakePipelineActivities) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(pipelineactivitiesResource, c.ns, opts))

}

// Create takes the representation of a pipelineActivity and creates it.  Returns the server's representation of the pipelineActivity, and an error, if there is any.
func (c *FakePipelineActivities) Create(ctx context.Context, pipelineActivity *v1.PipelineActivity, opts metav1.CreateOptions) (result *v1.PipelineActivity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(pipelineactivitiesResource, c.ns, pipelineActivity), &v1.PipelineActivity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1.PipelineActivity), err
}

// Update takes the representation of a pipelineActivity and updates it. Returns the server's representation of the pipelineActivity, and an error, if there is any.
func (c *FakePipelineActivities) Update(ctx context.Context, pipelineActivity *v1.PipelineActivity, opts metav1.UpdateOptions) (result *v1.PipelineActivity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(pipelineactivitiesResource, c.ns, pipelineActivity), &v1.PipelineActivity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1.PipelineActivity), err
}

// Delete takes name of the pipelineActivity and deletes it. Returns an error if one occurs.
func (c *FakePipelineActivities) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(pipelineactivitiesResource, c.ns, name, opts), &v1.PipelineActivity{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePipelineActivities) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(pipelineactivitiesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1.PipelineActivityList{})
	return err
}

// Patch applies the patch and returns the patched pipelineActivity.
func (c *FakePipelineActivities) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.PipelineActivity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(pipelineactivitiesResource, c.ns, name, pt, data, subresources...), &v1.PipelineActivity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1.PipelineActivity), err
}
